Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.commons.math.ode.nonstiff
Class DormandPrince54Integrator

    java.lang.Object
      org.apache.commons.math.ode.AbstractIntegrator
          org.apache.commons.math.ode.nonstiff.AdaptiveStepsizeIntegrator
              org.apache.commons.math.ode.nonstiff.EmbeddedRungeKuttaIntegrator
                  org.apache.commons.math.ode.nonstiff.DormandPrince54Integrator

All Implemented Interfaces:
  FirstOrderIntegrator, ODEIntegrator

    public class DormandPrince54Integrator

extends EmbeddedRungeKuttaIntegrator

This class implements the 5(4) Dormand-Prince integrator for Ordinary Differential Equations.

This integrator is an embedded Runge-Kutta integrator of order 5(4) used in local extrapolation mode (i.e. the solution is computed using the high order formula) with stepsize control (and automatic step initialization) and continuous output. This method uses 7 functions evaluations per step. However, since this is an fsal, the last evaluation of one step is the same as the first evaluation of the next step and hence can be avoided. So the cost is really 6 functions evaluations per step.

This method has been published (whithout the continuous output that was added by Shampine in 1986) in the following article :

      A family of embedded Runge-Kutta formulae
      J. R. Dormand and P. J. Prince
      Journal of Computational and Applied Mathematics
      volume 6, no 1, 1980, pp. 19-26

Since:
  1.2
Version:
  $Revision: 990655 $ $Date: 2010-08-29 23:49:40 +0200 (dim. 29 août 2010) $

Field Summary
`private static double` | `E1` Error array, element 1.
`private static double` | `E3` Error array, element 3.
`private static double` | `E4` Error array, element 4.
`private static double` | `E5` Error array, element 5.
`private static double` | `E6` Error array, element 6.
`private static double` | `E7` Error array, element 7.
`private static String` | `METHOD_NAME` Integrator method name.
`private static double[][]` | `STATIC_A` Internal weights Butcher array.
`private static double[]` | `STATIC_B` Propagation weights Butcher array.
`private static double[]` | `STATIC_C` Time steps Butcher array.

Fields inherited from class org.apache.commons.math.ode.nonstiff.AdaptiveStepsizeIntegrator
`mainSetDimension, scalAbsoluteTolerance, scalRelativeTolerance, vecAbsoluteTolerance, vecRelativeTolerance`

Fields inherited from class org.apache.commons.math.ode.AbstractIntegrator
`isLastStep, resetOccurred, stepHandlers, stepSize, stepStart`

Constructor Summary
`DormandPrince54Integrator(double minStep, double maxStep, double[] vecAbsoluteTolerance, double[] vecRelativeTolerance)` Simple constructor.
`DormandPrince54Integrator(double minStep, double maxStep, double scalAbsoluteTolerance, double scalRelativeTolerance)` Simple constructor.

Method Summary
`protected double` | `estimateError(double[][] yDotK, double[] y0, double[] y1, double h)` Compute the error ratio.
`int` | `getOrder()` Get the order of the method.

Methods inherited from class org.apache.commons.math.ode.nonstiff.EmbeddedRungeKuttaIntegrator
`getMaxGrowth, getMinReduction, getSafety, integrate, setMaxGrowth, setMinReduction, setSafety`

Methods inherited from class org.apache.commons.math.ode.nonstiff.AdaptiveStepsizeIntegrator
`filterStep, getCurrentStepStart, getMaxStep, getMinStep, initializeStep, resetInternalState, sanityChecks, setInitialStepSize`

Methods inherited from class org.apache.commons.math.ode.AbstractIntegrator
`acceptStep, addEndTimeChecker, addEventHandler, addStepHandler, clearEventHandlers, clearStepHandlers, computeDerivatives, getCurrentSignedStepsize, getEvaluations, getEventHandlers, getMaxEvaluations, getName, getStepHandlers, requiresDenseOutput, resetEvaluations, setEquations, setMaxEvaluations, setStateInitialized`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### METHOD_NAME

    private static final String METHOD_NAME

  Integrator method name.

  See Also:
    Constant Field Values

### STATIC_C

    private static final double[] STATIC_C

  Time steps Butcher array.

### STATIC_A

    private static final double[][] STATIC_A

  Internal weights Butcher array.

### STATIC_B

    private static final double[] STATIC_B

  Propagation weights Butcher array.

### E1

    private static final double E1

  Error array, element 1.

  See Also:
    Constant Field Values

### E3

    private static final double E3

  Error array, element 3.

  See Also:
    Constant Field Values

### E4

    private static final double E4

  Error array, element 4.

  See Also:
    Constant Field Values

### E5

    private static final double E5

  Error array, element 5.

  See Also:
    Constant Field Values

### E6

    private static final double E6

  Error array, element 6.

  See Also:
    Constant Field Values

### E7

    private static final double E7

  Error array, element 7.

  See Also:
    Constant Field Values

Constructor Detail

### DormandPrince54Integrator

    public DormandPrince54Integrator(double minStep,
                                     double maxStep,
                                     double scalAbsoluteTolerance,
                                     double scalRelativeTolerance)

  Simple constructor. Build a fifth order Dormand-Prince integrator with the given step bounds

  Parameters:
    `minStep` - minimal step (must be positive even for backward integration), the last step can be smaller than this
    `maxStep` - maximal step (must be positive even for backward integration)
    `scalAbsoluteTolerance` - allowed absolute error
    `scalRelativeTolerance` - allowed relative error

### DormandPrince54Integrator

    public DormandPrince54Integrator(double minStep,
                                     double maxStep,
                                     double[] vecAbsoluteTolerance,
                                     double[] vecRelativeTolerance)

  Simple constructor. Build a fifth order Dormand-Prince integrator with the given step bounds

  Parameters:
    `minStep` - minimal step (must be positive even for backward integration), the last step can be smaller than this
    `maxStep` - maximal step (must be positive even for backward integration)
    `vecAbsoluteTolerance` - allowed absolute error
    `vecRelativeTolerance` - allowed relative error

Method Detail

### getOrder

    public int getOrder()

  Get the order of the method.

  Specified by:
    `getOrder` in class `EmbeddedRungeKuttaIntegrator`
  Returns:
    order of the method

### estimateError

    protected double estimateError(double[][] yDotK,
                                   double[] y0,
                                   double[] y1,
                                   double h)

  Compute the error ratio.

  Specified by:
    `estimateError` in class `EmbeddedRungeKuttaIntegrator`
  Parameters:
    `yDotK` - derivatives computed during the first stages
    `y0` - estimate of the step at the start of the step
    `y1` - estimate of the step at the end of the step
    `h` - current step
  Returns:
    error ratio, greater than 1 if step should be rejected

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) 2003-2013 Apache Software Foundation